/* C code produced by gperf version 2.7.2 */
/* Command-line: gperf -tCcTonD -K id -N id3_frametype_lookup -s -3 -k '*' frametype.gperf  */
/*
 * libid3tag - ID3 tag manipulation library
 * Copyright (C) 2000-2003 Underbit Technologies, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: frametype.c,v 1.3 2003/07/25 23:23:21 robert Exp $
 */

# ifdef HAVE_CONFIG_H
#  include "config.h"
# endif

# include "global.h"

# include <string.h>

# include "id3tag.h"
# include "frametype.h"

# define FIELDS(id)  static enum id3_field_type const fields_##id[]

/* frame field descriptions */

FIELDS(UFID) = {
  ID3_FIELD_TYPE_LATIN1,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(TXXX) = {
  ID3_FIELD_TYPE_TEXTENCODING,
  ID3_FIELD_TYPE_STRING,
  ID3_FIELD_TYPE_STRING
};

FIELDS(WXXX) = {
  ID3_FIELD_TYPE_TEXTENCODING,
  ID3_FIELD_TYPE_STRING,
  ID3_FIELD_TYPE_LATIN1
};

FIELDS(MCDI) = {
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(ETCO) = {
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(MLLT) = {
  ID3_FIELD_TYPE_INT16,
  ID3_FIELD_TYPE_INT24,
  ID3_FIELD_TYPE_INT24,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(SYTC) = {
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(USLT) = {
  ID3_FIELD_TYPE_TEXTENCODING,
  ID3_FIELD_TYPE_LANGUAGE,
  ID3_FIELD_TYPE_STRING,
  ID3_FIELD_TYPE_STRINGFULL
};

FIELDS(SYLT) = {
  ID3_FIELD_TYPE_TEXTENCODING,
  ID3_FIELD_TYPE_LANGUAGE,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_STRING,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(COMM) = {
  ID3_FIELD_TYPE_TEXTENCODING,
  ID3_FIELD_TYPE_LANGUAGE,
  ID3_FIELD_TYPE_STRING,
  ID3_FIELD_TYPE_STRINGFULL
};

FIELDS(RVA2) = {
  ID3_FIELD_TYPE_LATIN1,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(EQU2) = {
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_LATIN1,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(RVRB) = {
  ID3_FIELD_TYPE_INT16,
  ID3_FIELD_TYPE_INT16,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_INT8
};

FIELDS(APIC) = {
  ID3_FIELD_TYPE_TEXTENCODING,
  ID3_FIELD_TYPE_LATIN1,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_STRING,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(GEOB) = {
  ID3_FIELD_TYPE_TEXTENCODING,
  ID3_FIELD_TYPE_LATIN1,
  ID3_FIELD_TYPE_STRING,
  ID3_FIELD_TYPE_STRING,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(PCNT) = {
  ID3_FIELD_TYPE_INT32PLUS
};

FIELDS(POPM) = {
  ID3_FIELD_TYPE_LATIN1,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_INT32PLUS
};

FIELDS(RBUF) = {
  ID3_FIELD_TYPE_INT24,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_INT32
};

FIELDS(AENC) = {
  ID3_FIELD_TYPE_LATIN1,
  ID3_FIELD_TYPE_INT16,
  ID3_FIELD_TYPE_INT16,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(LINK) = {
  ID3_FIELD_TYPE_FRAMEID,
  ID3_FIELD_TYPE_LATIN1,
  ID3_FIELD_TYPE_LATIN1LIST
};

FIELDS(POSS) = {
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(USER) = {
  ID3_FIELD_TYPE_TEXTENCODING,
  ID3_FIELD_TYPE_LANGUAGE,
  ID3_FIELD_TYPE_STRING
};

FIELDS(OWNE) = {
  ID3_FIELD_TYPE_TEXTENCODING,
  ID3_FIELD_TYPE_LATIN1,
  ID3_FIELD_TYPE_DATE,
  ID3_FIELD_TYPE_STRING
};

FIELDS(COMR) = {
  ID3_FIELD_TYPE_TEXTENCODING,
  ID3_FIELD_TYPE_LATIN1,
  ID3_FIELD_TYPE_DATE,
  ID3_FIELD_TYPE_LATIN1,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_STRING,
  ID3_FIELD_TYPE_STRING,
  ID3_FIELD_TYPE_LATIN1,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(ENCR) = {
  ID3_FIELD_TYPE_LATIN1,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(GRID) = {
  ID3_FIELD_TYPE_LATIN1,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(PRIV) = {
  ID3_FIELD_TYPE_LATIN1,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(SIGN) = {
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(SEEK) = {
  ID3_FIELD_TYPE_INT32
};

FIELDS(ASPI) = {
  ID3_FIELD_TYPE_INT32,
  ID3_FIELD_TYPE_INT32,
  ID3_FIELD_TYPE_INT16,
  ID3_FIELD_TYPE_INT8,
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(text) = {
  ID3_FIELD_TYPE_TEXTENCODING,
  ID3_FIELD_TYPE_STRINGLIST
};

FIELDS(url) = {
  ID3_FIELD_TYPE_LATIN1
};

FIELDS(unknown) = {
  ID3_FIELD_TYPE_BINARYDATA
};

FIELDS(ZOBS) = {
  ID3_FIELD_TYPE_FRAMEID,
  ID3_FIELD_TYPE_BINARYDATA
};

# define FRAME(id)  \
  sizeof(fields_##id) / sizeof(fields_##id[0]), fields_##id

# define PRESERVE  0
# define DISCARD   ID3_FRAME_FLAG_FILEALTERPRESERVATION
# define OBSOLETE  (DISCARD | ID3_FRAME_FLAG_TAGALTERPRESERVATION)

# define FRAMETYPE(type, id, flags, desc)  \
  struct id3_frametype const id3_frametype_##type = {  \
    0, FRAME(id), flags, desc  \
  }

/* static frame types */

FRAMETYPE(text,         text,    PRESERVE, "Unknown text information frame");
FRAMETYPE(url,          url,     PRESERVE, "Unknown URL link frame");
FRAMETYPE(experimental, unknown, PRESERVE, "Experimental frame");
FRAMETYPE(unknown,      unknown, PRESERVE, "Unknown frame");
FRAMETYPE(obsolete,     unknown, OBSOLETE, "Obsolete frame");

#define TOTAL_KEYWORDS 88
#define MIN_WORD_LENGTH 4
#define MAX_WORD_LENGTH 4
#define MIN_HASH_VALUE 2
#define MAX_HASH_VALUE 113
/* maximum key range = 112, duplicates = 15 */

#ifdef __GNUC__
__inline
#else
#ifdef __cplusplus
inline
#endif
#endif
static unsigned int
hash (str, len)
     register const char *str;
     register unsigned int len;
{
  static const unsigned char asso_values[] =
    {
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114,   2,
        6,  28,  20, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114,  30,   1,  30,  30,  15,
        9,  28, 114,   0, 114,  15,   6,   4,  12,   0,
        8,   0,  22,  31,   0,  18,  30,  20,  31,   5,
        0, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
      114, 114, 114, 114, 114, 114
    };
  register int hval = 0;

  switch (len)
    {
      default:
      case 4:
        hval += asso_values[(unsigned char)str[3]];
      case 3:
        hval += asso_values[(unsigned char)str[2]];
      case 2:
        hval += asso_values[(unsigned char)str[1]];
      case 1:
        hval += asso_values[(unsigned char)str[0]];
        break;
    }
  return hval;
}

#ifdef __GNUC__
__inline
#endif
const struct id3_frametype *
id3_frametype_lookup (str, len)
     register const char *str;
     register unsigned int len;
{
  static const struct id3_frametype wordlist[] =
    {
      {"TIT1", FRAME(text), PRESERVE, "Content group description"},
      {"TMOO", FRAME(text), PRESERVE, "Mood"},
      {"TIT2", FRAME(text), PRESERVE, "Title/songname/content description"},
      {"TOLY", FRAME(text), PRESERVE, "Original lyricist(s)/text writer(s)"},
      {"TBPM", FRAME(text), PRESERVE, "BPM (beats per minute)"},
      {"TIPL", FRAME(text), PRESERVE, "Involved people list"},
      {"TFLT", FRAME(text), PRESERVE, "File type"},
      {"MLLT", FRAME(MLLT), DISCARD,  "MPEG location lookup table"},
      {"TIME", FRAME(text), PRESERVE, "Time"},
      {"POPM", FRAME(POPM), PRESERVE, "Popularimeter"},
      {"TOFN", FRAME(text), PRESERVE, "Original filename"},
      {"TOPE", FRAME(text), PRESERVE, "Original artist(s)/performer(s)"},
      {"TPE1", FRAME(text), PRESERVE, "Lead performer(s)/soloist(s)"},
      {"TPUB", FRAME(text), PRESERVE, "Publisher"},
      {"TIT3", FRAME(text), PRESERVE, "Subtitle/description refinement"},
      {"TPE2", FRAME(text), PRESERVE, "Band/orchestra/accompaniment"},
      {"TPRO", FRAME(text), PRESERVE, "Produced notice"},
      {"TSOT", FRAME(text), PRESERVE, "Title sort order"},
      {"ZOBS", FRAME(ZOBS), OBSOLETE, "Obsolete frame"},
      {"TOWN", FRAME(text), PRESERVE, "File owner/licensee"},
      {"TLEN", FRAME(text), DISCARD,  "Length"},
      {"LINK", FRAME(LINK), PRESERVE, "Linked information"},
      {"TCOM", FRAME(text), PRESERVE, "Composer"},
      {"TKEY", FRAME(text), PRESERVE, "Initial key"},
      {"TOAL", FRAME(text), PRESERVE, "Original album/movie/show title"},
      {"TALB", FRAME(text), PRESERVE, "Album/movie/show title"},
      {"COMM", FRAME(COMM), PRESERVE, "Comments"},
      {"TCOP", FRAME(text), PRESERVE, "Copyright message"},
      {"TPOS", FRAME(text), PRESERVE, "Part of a set"},
      {"TSOP", FRAME(text), PRESERVE, "Performer sort order"},
      {"EQU2", FRAME(EQU2), DISCARD,  "Equalisation (2)"},
      {"TMCL", FRAME(text), PRESERVE, "Musician credits list"},
      {"TDLY", FRAME(text), PRESERVE, "Playlist delay"},
      {"TYER", FRAME(text), PRESERVE, "Year"},
      {"SYLT", FRAME(SYLT), DISCARD,  "Synchronised lyric/text"},
      {"TCON", FRAME(text), PRESERVE, "Content type"},
      {"TPE4", FRAME(text), PRESERVE, "Interpreted, remixed, or otherwise modified by"},
      {"GEOB", FRAME(GEOB), PRESERVE, "General encapsulated object"},
      {"ETCO", FRAME(ETCO), DISCARD,  "Event timing codes"},
      {"TEXT", FRAME(text), PRESERVE, "Lyricist/text writer"},
      {"WPUB", FRAME(url),  PRESERVE, "Publishers official webpage"},
      {"OWNE", FRAME(OWNE), PRESERVE, "Ownership frame"},
      {"TLAN", FRAME(text), PRESERVE, "Language(s)"},
      {"TMED", FRAME(text), PRESERVE, "Media type"},
      {"PCNT", FRAME(PCNT), PRESERVE, "Play counter"},
      {"RBUF", FRAME(RBUF), PRESERVE, "Recommended buffer size"},
      {"TPE3", FRAME(text), PRESERVE, "Conductor/performer refinement"},
      {"TDOR", FRAME(text), PRESERVE, "Original release time"},
      {"TRSO", FRAME(text), PRESERVE, "Internet radio station owner"},
      {"WCOM", FRAME(url),  PRESERVE, "Commercial information"},
      {"USLT", FRAME(USLT), PRESERVE, "Unsynchronised lyric/text transcription"},
      {"COMR", FRAME(COMR), PRESERVE, "Commercial frame"},
      {"UFID", FRAME(UFID), PRESERVE, "Unique file identifier"},
      {"TENC", FRAME(text), DISCARD,  "Encoded by"},
      {"TDEN", FRAME(text), PRESERVE, "Encoding time"},
      {"WCOP", FRAME(url),  PRESERVE, "Copyright/legal information"},
      {"TDRL", FRAME(text), PRESERVE, "Release time"},
      {"TDTG", FRAME(text), PRESERVE, "Tagging time"},
      {"WOAF", FRAME(url),  PRESERVE, "Official audio file webpage"},
      {"PRIV", FRAME(PRIV), PRESERVE, "Private frame"},
      {"TDAT", FRAME(text), PRESERVE, "Date"},
      {"TSOA", FRAME(text), PRESERVE, "Album sort order"},
      {"TSST", FRAME(text), PRESERVE, "Set subtitle"},
      {"WPAY", FRAME(url),  PRESERVE, "Payment"},
      {"MCDI", FRAME(MCDI), PRESERVE, "Music CD identifier"},
      {"TRSN", FRAME(text), PRESERVE, "Internet radio station name"},
      {"SYTC", FRAME(SYTC), DISCARD,  "Synchronised tempo codes"},
      {"TRCK", FRAME(text), PRESERVE, "Track number/position in set"},
      {"APIC", FRAME(APIC), PRESERVE, "Attached picture"},
      {"ASPI", FRAME(ASPI), DISCARD,  "Audio seek point index"},
      {"XSOP", FRAME(text), PRESERVE, "Performer Sort Order"},
      {"POSS", FRAME(POSS), DISCARD,  "Position synchronisation frame"},
      {"SIGN", FRAME(SIGN), PRESERVE, "Signature frame"},
      {"WOAR", FRAME(url),  PRESERVE, "Official artist/performer webpage"},
      {"WORS", FRAME(url),  PRESERVE, "Official Internet radio station homepage"},
      {"RVRB", FRAME(RVRB), PRESERVE, "Reverb"},
      {"SEEK", FRAME(SEEK), DISCARD,  "Seek frame"},
      {"TSSE", FRAME(text), PRESERVE, "Software/hardware and settings used for encoding"},
      {"ENCR", FRAME(ENCR), PRESERVE, "Encryption method registration"},
      {"GRID", FRAME(GRID), PRESERVE, "Group identification registration"},
      {"WOAS", FRAME(url),  PRESERVE, "Official audio source webpage"},
      {"TDRC", FRAME(text), PRESERVE, "Recording time"},
      {"TSRC", FRAME(text), PRESERVE, "ISRC (international standard recording code)"},
      {"USER", FRAME(USER), PRESERVE, "Terms of use"},
      {"AENC", FRAME(AENC), DISCARD,  "Audio encryption"},
      {"RVA2", FRAME(RVA2), DISCARD,  "Relative volume adjustment (2)"},
      {"TXXX", FRAME(TXXX), PRESERVE, "User defined text information frame"},
      {"WXXX", FRAME(WXXX), PRESERVE, "User defined URL link frame"}
    };

  static const short lookup[] =
    {
        -1,   -1,    0,   -1,    1,   -1,    2,   -1,
        -1,   -1,   -1,    3,   -1,    4,    5,    6,
         7,   -1,   -1,    8,    9,   10,   -1,   11,
        -1,   12,   -1,   13,   14,   15,   16,   17,
      -197, -195,   22,   23,   24,   25, -193, -191,
        31,   32, -189,   36,   37,   38,   39, -187,
        42,   43, -185,   46,   47,   48,   49,   50,
        51, -183, -180,   58, -178,   61,   62,   63,
        64,   65,   66,   67,   68,   69, -173,   72,
        73,   74,   -1,   75,   76,   77,   -1,   78,
        79,   80,   81,   82,  -18,   -2,   83,   84,
        85,  -29,   -2,  -33,   -3,   86,  -36,   -3,
       -44,   -2,  -48,   -2,  -55,   -3,  -60,   -3,
       -62,   -2,  -68,   -2,  -70,   -2,   -1,   -1,
        -1,   87
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= 0)
        {
          register int index = lookup[key];

          if (index >= 0)
            {
              register const char *s = wordlist[index].id;

              if (*str == *s && !strncmp (str + 1, s + 1, len - 1) && s[len] == '\0')
                return &wordlist[index];
            }
          else if (index < -TOTAL_KEYWORDS)
            {
              register int offset = - 1 - TOTAL_KEYWORDS - index;
              register const struct id3_frametype *wordptr = &wordlist[TOTAL_KEYWORDS + lookup[offset]];
              register const struct id3_frametype *wordendptr = wordptr + -lookup[offset + 1];

              while (wordptr < wordendptr)
                {
                  register const char *s = wordptr->id;

                  if (*str == *s && !strncmp (str + 1, s + 1, len - 1) && s[len] == '\0')
                    return wordptr;
                  wordptr++;
                }
            }
        }
    }
  return 0;
}
